: Interface CharIndexed

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.regexp
Interface CharIndexed

public interface CharIndexed

Defines the interface used internally so that different types of source text can be accessed in the same way. Built-in concrete classes provide support for String, StringBuffer, InputStream and char[] types. A class that is CharIndexed supports the notion of a cursor within a block of text. The cursor must be able to be advanced via the move() method. The charAt() method returns the character at the cursor position plus a given offset.

Author:
  Wes Biggs

Field Summary
`static char` | `OUT_OF_BOUNDS` Defines a constant (0xFFFF was somewhat arbitrarily chosen) that can be returned by the charAt() function indicating that the specified index is out of range.

Method Summary
`char` | `charAt(int index)` Returns the character at the given offset past the current cursor position in the input.
`boolean` | `isValid()` Returns true if the most recent move() operation placed the cursor position at a valid position in the input.
`boolean` | `move(int index)` Shifts the input buffer by a given number of positions.

Field Detail

### OUT_OF_BOUNDS

    public static final char OUT_OF_BOUNDS

  Defines a constant (0xFFFF was somewhat arbitrarily chosen) that can be returned by the charAt() function indicating that the specified index is out of range.

Method Detail

### charAt

    public char charAt(int index)

  Returns the character at the given offset past the current cursor position in the input. The index of the current position is zero. It is possible for this method to be called with a negative index. This happens when using the '^' operator in multiline matching mode or the '\b' or '\<' word boundary operators. In any case, the lower bound is currently fixed at -2 (for '^' with a two-character newline).
  Parameters:
    `index` - the offset position in the character field to examine
  Returns:
    the character at the specified index, or the OUT_OF_BOUNDS character defined by this interface.

### move

    public boolean move(int index)

  Shifts the input buffer by a given number of positions. Returns true if the new cursor position is valid.

### isValid

    public boolean isValid()

  Returns true if the most recent move() operation placed the cursor position at a valid position in the input.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD